<template>
    <div class="win-today-container relative rounded-lg py-4">
        <div class="flex gap-1 items-center pb-[8px]">
            <img
                class="w-[24px] h-[24px]"
                :src="getAssetImage(`assets/theme/playful/images/ranking.png`)"
            />
            <span class="font-bold text-sm capitalize">{{ $t('Win Today')  }}</span>
        </div>
        <el-table :data="orderBy(data, 'TotalRevenue', 'desc').slice(0, 5)" :header-cell-style="{textAlign: 'center'}" :cell-style="{textAlign: 'center'}" border class="win-today-table">
            <el-table-column :label="$t('Ranking')" :width="isMobile ? 80 : 120" fixed>
                <template #default="scope">
                    <div v-if="scope.$index < 3" class="flex justify-center">
                        <img class="object-contain h-[24px] w-[24px] rounded-lg" v-lazy="getAssetImage(`assets/theme/playful/images/top-ranking-${scope.$index + 1}.svg`)" alt="">
                    </div>
                    <div v-else>{{ scope.$index + 1 }}</div>
                </template>
            </el-table-column>
            <el-table-column :label="$t('Player')" :min-width="isMobile ? 160 : 320">
                <template #default="scope">
                    <div class="flex justify-center items-center gap-1">
                        <img class="object-contain h-[16px] w-[16px] rounded-lg" v-lazy="getAssetImage(`assets/theme/playful/images/icon-user.svg`)" alt="">
                        <div>{{ scope.row.PlayerName }}</div>
                    </div>
                </template>
            </el-table-column>
            <el-table-column prop="GameName" :label="$t('game')" :min-width="isMobile ? 160 : 320"/>
            <el-table-column :label="$t('Total Revenue')" :min-width="isMobile ? 160 : 320">
                <template #default="scope">
                    <div class="flex justify-center items-center gap-1">
                        <img class="object-contain h-[16px] w-[16px] rounded-lg" v-lazy="getAssetImage(`assets/theme/playful/images/gold-coin.svg`)" alt="">
                        <div>{{ scope.row.TotalRevenue }}</div>
                    </div>
                </template>
            </el-table-column>
        </el-table>
    </div>
</template>

<script lang="ts" setup>
import { gameStore } from '~~/store/game';
import { orderBy } from 'lodash-es'
import { store } from '~~/store';
import numberFormatHelper from '~~/utils/formatHelpers/numberFormatHelper';

const isMobile = useDevice().isMobile;
const { getAssetImage } = commonHelper;
const randomizeName = () => {
  const letters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  let name = '';

  for (let i = 0; i < 2; i++) {
    name += letters.charAt(Math.floor(Math.random() * letters.length));
  }

  name += '****';

  for (let i = 0; i < 2; i++) {
    name += Math.floor(Math.random() * 10);
  }

  return name;
}

const revenueRange: Record<string, {min: number, max: number}> = {
    AED: {
        min: 14720,
        max: 25760,
    },
    AUD: {
        min: 5760,
        max: 10080,
    },
    CAD: {
        min: 5216,
        max: 9152,
    },
    CHF: {
        min: 4400,
        max: 7700,
    },
    CNY: {
        min: 25800,
        max: 45150,
    },
    EUR: {
        min: 3544,
        max: 6202,
    },
    GBP: {
        min: 3432,
        max: 6002,
    },
    HKD: {
        min: 31200,
        max: 54600,
    },
    IDR: {
        min: 5000000,
        max: 7000000,
    },
    JPY: {
        min: 463600,
        max: 811900,
    },
    KRW: {
        min: 4694800,
        max: 8220100,
    },
    LAK: {
        min: 36000000,
        max: 63000000,
    },
    MMK: {
        min: 36000000,
        max: 63000000,
    },
    MYR: {
        min: 6800000,
        max: 11900000,
    },
    NOK: {
        min: 35520,
        max: 62160,
    },
    NZD: {
        min: 5792,
        max: 10136,
    },
    SEK: {
        min: 35040,
        max: 61320,
    },
    THB: {
        min: 132000,
        max: 231000,
    },
    TMP: {
        min: 3000,
        max: 5250,
    },
    UCC: {
        min: 4000,
        max: 7000,
    },
    VND: {
        min: 58320,
        max: 101710,
    },
    ZAR: {
        min: 58320,
        max: 101710,
    },
    USD: {
        min: 4000,
        max: 7000,
    }
};

const currency = computed(() => store.state.currency);

const randomizeAmount = () => {
  const currencyCode = currency.value

  if (revenueRange.hasOwnProperty(currencyCode)) {
    const { min, max } = revenueRange[currencyCode];
    const amount = Math.random() * (max - min) + min;
    const randomDecimal = Math.floor(Math.random() * 100);
    const formattedAmount = (amount + randomDecimal / 100).toFixed(2);
    return numberFormatHelper.addAccountingFormatWithoutRoundUp(Number(formattedAmount), 2);
  }
  const { min, max } = revenueRange['USD'];
  const amount = Math.random() * (max - min) + min;
  const randomDecimal = Math.floor(Math.random() * 100);
  const formattedAmount = (amount + randomDecimal / 100).toFixed(2);

  return numberFormatHelper.addAccountingFormatWithoutRoundUp(Number(formattedAmount), 2);
}
interface IData {
    PlayerName: string,
    GameName: string,
    TotalRevenue: string,
}
const data = ref<IData[]>([]);
const playableGame = computed(() =>
  gameStore.state.games.filter((game) => game.Category === 3)
);

const currentDate = new Date();
const dateString = currentDate.toISOString().slice(0, 10);

const randomizeData = async () => {
    const storedDate = localStorage.getItem('todaysDate');
    if (storedDate) {
        const today = new Date();
        const storedDateObj = new Date(storedDate);
        if (today.getDate() > storedDateObj.getDate()) {
            for (let i = 0; i < 20; i++) {
                const randomIndex = Math.floor(Math.random() * playableGame.value.length);
                data.value.push({
                    PlayerName: randomizeName(),
                    GameName: playableGame.value[randomIndex]?.GameName,
                    TotalRevenue: randomizeAmount(),
                })
            }
            localStorage.setItem('winTodayList', JSON.stringify(data.value));
            localStorage.setItem('todaysDate', dateString);
        } else {
            const list = localStorage.getItem('winTodayList') ?? '[]';
            data.value = JSON.parse(list);
        }
    } else {
        for (let i = 0; i < 20; i++) {
            const randomIndex = Math.floor(Math.random() * playableGame.value.length);
            data.value.push({
                PlayerName: randomizeName(),
                GameName: playableGame.value[randomIndex]?.GameName,
                TotalRevenue: randomizeAmount(),
            })
        }
        localStorage.setItem('winTodayList', JSON.stringify(data.value));
        localStorage.setItem('todaysDate', dateString);
    }
}

randomizeData();

setInterval(() => {
    const now = new Date();
    const hour = now.getHours();
    const minute = now.getMinutes();
    const second = now.getSeconds();
    if ((hour === 0 && minute === 0 && second === 0)) randomizeData();
}, 1000);
setInterval(() => {
    data.value = data.value.map((item) => {
        const splittedItem = item.TotalRevenue.split('.');
        splittedItem[0] = String(Number(splittedItem[0].replace(',', '')) + Math.floor(Math.random() * 21));
        splittedItem[1] = String(Number(splittedItem[1].replace(',', '')) + Math.floor(Math.random() * 100));
        item.TotalRevenue = numberFormatHelper.addAccountingFormatWithoutRoundUp(Number(splittedItem.join('.')), 2);
        return item;
    });
    localStorage.setItem('winTodayList', JSON.stringify(data.value));
}, 1000 * 60);
</script>

<style lang="scss">
[layout="playful"][data-device="mobile"] {
    .win-today-container {
        padding-bottom: 8px !important;
    }
}
.win-today-container {
    .el-table {
        border-radius: 8px;
        --el-table-border-color: var(--background5);
        --el-table-header-bg-color: var(background5);
        font-weight: bold;
        .el-table__header-wrapper {
            .el-table__header {
                thead {
                    th {
                        border-color: var(--border);
                        background: var(--background5);
                    }
                }
            }
        }
        .el-table__inner-wrapper {
            .el-table__body-wrapper {
                tbody {
                    .el-table__row {
                        .el-table-fixed-column--left {
                            background-color: var(--background5);
                        }
                        background-color: var(--background5);
                        td {
                            border-right: none;
                            border-left: none;
                            border-color: var(--border);
                            height: 48px;
                        }
                    }
                }
            }
        }
    }
}
</style>

<style scoped>
</style>